Index: squid/src/errorpage.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/errorpage.c,v
retrieving revision 1.5.2.8
retrieving revision 1.5.2.9
diff -u -r1.5.2.8 -r1.5.2.9
--- squid/src/errorpage.c	1 Jul 2007 05:44:22 -0000	1.5.2.8
+++ squid/src/errorpage.c	2 Jul 2007 07:36:59 -0000	1.5.2.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: errorpage.c,v 1.5.2.8 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: errorpage.c,v 1.5.2.9 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 4     Error Generation
  * AUTHOR: Duane Wessels
@@ -507,7 +507,7 @@
 	    p = "[unknown host]";
 	break;
     case 'i':
-	memBufPrintf(&mb, "%s", sockaddr_ntoa(&err->src_addr));
+	memBufPrintf(&mb, "%s", inet_ntoa(err->src_addr));
 	break;
     case 'I':
 	if (r && r->hier.host) {
Index: squid/src/external_acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/external_acl.c,v
retrieving revision 1.12.2.3
retrieving revision 1.12.2.4
diff -u -r1.12.2.3 -r1.12.2.4
--- squid/src/external_acl.c	1 Jul 2007 05:44:22 -0000	1.12.2.3
+++ squid/src/external_acl.c	2 Jul 2007 07:36:59 -0000	1.12.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: external_acl.c,v 1.12.2.3 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: external_acl.c,v 1.12.2.4 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 82    External ACL
  * AUTHOR: Henrik Nordstrom, MARA Systems AB
@@ -643,14 +643,14 @@
 	    break;
 #endif
 	case EXT_ACL_SRC:
-	    str = sockaddr_ntoa(&ch->src_addr);
+	    str = inet_ntoa(ch->src_addr);
 	    break;
 	case EXT_ACL_SRCPORT:
 	    snprintf(buf, sizeof(buf), "%d", request->client_port);
 	    str = buf;
 	    break;
 	case EXT_ACL_MYADDR:
-	    str = sockaddr_ntoa(&request->my_addr);
+	    str = inet_ntoa(request->my_addr);
 	    break;
 	case EXT_ACL_MYPORT:
 	    snprintf(buf, sizeof(buf), "%d", request->my_port);
Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.4.6.9
retrieving revision 1.4.6.10
diff -u -r1.4.6.9 -r1.4.6.10
--- squid/src/forward.c	1 Jul 2007 08:34:28 -0000	1.4.6.9
+++ squid/src/forward.c	2 Jul 2007 07:36:59 -0000	1.4.6.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.4.6.9 2007/07/01 08:34:28 amosjeffries Exp $
+ * $Id: forward.c,v 1.4.6.10 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -351,15 +351,6 @@
 	err->dnsserver_msg = xstrdup(dns_error_message);
 	fwdFail(fwdState, err);
 	comm_close(server_fd);
-    } else if (status == COMM_ERR_INV_ARGS) {
-	assert(fs);
-	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, fwdState->request);
-	err->xerrno = errno;
-	fwdState->server_fd_was_inv_args = 1;
-	fwdFail(fwdState, err);
-	if (fs->peer)
-	    peerConnectFailed(fs->peer);
-	comm_close(server_fd);
     } else if (status != COMM_OK) {
 	assert(fs);
 	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, fwdState->request);
@@ -406,20 +397,17 @@
     comm_close(fd);
 }
 
-static struct sockaddr_storage *
+static struct in_addr
 aclMapAddr(acl_address * head, aclCheck_t * ch)
 {
     acl_address *l;
-    struct sockaddr_storage *addr;
-    struct sockaddr_in *addr4;
+    struct in_addr addr;
     aclChecklistCacheInit(ch);
     for (l = head; l; l = l->next) {
 	if (aclMatchAclList(l->acl_list, ch))
-	    return &l->addr;
+	    return l->addr;
     }
-    addr = xmalloc(sizeof(struct sockaddr_storage));
-    addr4 = (struct sockaddr_in *)addr;
-    addr4->sin_addr.s_addr = INADDR_ANY;
+    addr.s_addr = INADDR_ANY;
     return addr;
 }
 
@@ -435,7 +423,7 @@
     return 0;
 }
 
-struct sockaddr_storage *
+struct in_addr
 getOutgoingAddr(request_t * request)
 {
     aclCheck_t ch;
@@ -467,13 +455,11 @@
     FwdServer *fs = fwdState->servers;
     const char *host;
     const char *name;
-    char portstr[8];
     unsigned short port;
     const char *domain = NULL;
     int ctimeout;
     int ftimeout = Config.Timeout.forward - (squid_curtime - fwdState->start);
-    struct sockaddr_storage outgoing, peerinfo;
-    struct addrinfo hints, *res;
+    struct in_addr outgoing;
     unsigned short tos;
 #if LINUX_TPROXY
     struct in_tproxy itp;
@@ -482,9 +468,6 @@
     assert(fs);
     assert(fwdState->server_fd == -1);
     debug(17, 3) ("fwdConnectStart: %s\n", url);
-    debug(17, 3) ("  fwdState: 0x%x was IPv4: %d tries: %d err: %d\n", 
-		fwdState, fwdState->server_fd_was_v4, fwdState->n_tries, 
-		fwdState->err ? fwdState->err->xerrno : 0);
     if (fs->peer) {
 	host = fs->peer->host;
 	name = fs->peer->name;
@@ -533,7 +516,7 @@
 	fd = pconnPop(name, port, domain, &fwdState->request->client_addr, 0);
 #endif
     if (fd == -1)
-	fd = pconnPop(name, port, domain, NULL);
+	fd = pconnPop(name, port, domain, NULL, 0);
     if (fd != -1) {
 	/* Don't cache if the returned fd does not have valid DNS */
 	if (fd_table[fd].flags.dnsfailed)
@@ -564,46 +547,17 @@
 #if URL_CHECKSUM_DEBUG
     assert(fwdState->entry->mem_obj->chksum == url_checksum(url));
 #endif
-
-    if (fwdState->server_fd_was_inv_args) {
-      fwdState->n_tries--;
-      if (!fs->peer)
-          fwdState->origin_tries--;
-    }
-    else
-      fwdState->ia_cur = -1;
-    memset(&outgoing, 0, sizeof(outgoing));
-    if (fwdState->server_fd_was_v4)
-      outgoing.ss_family = fwdState->server_fd_was_inv_args ?
-                              AF_INET6 : AF_INET ;
-    else
-      outgoing.ss_family = fwdState->server_fd_was_inv_args ?
-                              AF_INET : AF_INET6 ;
-
-    fwdState->server_fd_was_inv_args = 0;
-    if (fs->peer && fs->peer->in_addr.ss_family == AF_INET6)
-      outgoing.ss_family = AF_INET6;
-    if (outgoing.ss_family == AF_INET)
-      fwdState->server_fd_was_v4 = 1;
-    else
-      fwdState->server_fd_was_v4 = 0;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-    outgoing.ss_len = outgoing.ss_family == AF_INET6 ?
-      sizeof(struct sockaddr_in6) : sizeof(struct sockaddr_in);
-#endif
-    tos = 0;
-/* HUSNI skip ACL
     outgoing = getOutgoingAddr(fwdState->request);
     tos = getOutgoingTOS(fwdState->request);
-*/
 
     fwdState->request->out_ip = outgoing;
 
     debug(17, 3) ("fwdConnectStart: got addr %s, tos %d\n",
-	sockaddr_ntoa(&outgoing), tos);
+	inet_ntoa(outgoing), tos);
     fd = comm_openex(SOCK_STREAM,
 	IPPROTO_TCP,
-	&outgoing,
+	outgoing,
+	0,
 	COMM_NONBLOCKING,
 	tos,
 	url);
@@ -872,8 +826,7 @@
      * from peer_digest.c, asn.c, netdb.c, etc and should always
      * be allowed.  yuck, I know.
      */
-    if (((struct sockaddr_in *)&r->client_addr)->sin_addr.s_addr != no_addr.s_addr
-            && r->protocol != PROTO_INTERNAL && r->protocol != PROTO_CACHEOBJ) {
+    if (r->client_addr.s_addr != no_addr.s_addr && r->protocol != PROTO_INTERNAL && r->protocol != PROTO_CACHEOBJ) {
 	/*      
 	 * Check if this host is allowed to fetch MISSES from us (miss_access)
 	 */
@@ -926,7 +879,9 @@
 #if LINUX_TPROXY
     /* If we need to transparently proxy the request
      * then we need the client source address and port */
-    xmemcpy(&fwdState->src, &r->client_addr, sizeof(struct sockaddr_storage));
+    fwdState->src.sin_family = AF_INET;
+    fwdState->src.sin_addr = r->client_addr;
+    fwdState->src.sin_port = r->client_port;
 #endif
 
     storeLockObject(e);
@@ -1000,11 +955,6 @@
 	err_type_str[errorState->type],
 	httpStatusString(errorState->http_status),
 	storeUrl(fwdState->entry));
-    if (fwdState->server_fd_was_inv_args) {
-	errorStateFree(errorState);
-	return;
-    }
-    fwdState->server_fd_was_inv_args = 0;
     if (fwdState->err)
 	errorStateFree(fwdState->err);
     fwdState->err = errorState;
Index: squid/src/fqdncache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fqdncache.c,v
retrieving revision 1.4.6.7
retrieving revision 1.4.6.8
diff -u -r1.4.6.7 -r1.4.6.8
--- squid/src/fqdncache.c	1 Jul 2007 05:44:22 -0000	1.4.6.7
+++ squid/src/fqdncache.c	2 Jul 2007 07:36:59 -0000	1.4.6.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fqdncache.c,v 1.4.6.7 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: fqdncache.c,v 1.4.6.8 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 35    FQDN Cache
  * AUTHOR: Harvest Derived
@@ -351,12 +351,11 @@
 }
 
 void
-fqdncache_nbgethostbyaddr(struct sockaddr *addr, FQDNH * handler, void *handlerData)
+fqdncache_nbgethostbyaddr(struct in_addr addr, FQDNH * handler, void *handlerData)
 {
     fqdncache_entry *f = NULL;
-    char name[80]; 
+    char *name = inet_ntoa(addr);
     generic_cbdata *c;
-    getnameinfo(addr, SOCKLEN(addr), name, 80, NULL, 0, NULL);
     assert(handler);
     debug(35, 4) ("fqdncache_nbgethostbyaddr: Name '%s'.\n", name);
     FqdncacheStats.requests++;
@@ -428,12 +427,11 @@
 }
 
 const char *
-fqdncache_gethostbyaddr(struct sockaddr *addr, int flags)
+fqdncache_gethostbyaddr(struct in_addr addr, int flags)
 {
-    char name[80]; 
+    char *name = inet_ntoa(addr);
     fqdncache_entry *f = NULL;
     struct in_addr ip;
-    getnameinfo(addr, SOCKLEN(addr), name, 80, NULL, 0, NULL);
     assert(name);
     FqdncacheStats.requests++;
     f = fqdncache_get(name);
@@ -454,7 +452,7 @@
     }
     dns_error_message = NULL;
     /* check if it's already a FQDN address in text form. */
-    if (!safe_inet_addr(name, &ip)) 
+    if (!safe_inet_addr(name, &ip))
 	return name;
     FqdncacheStats.misses++;
     if (flags & FQDN_LOOKUP_IF_MISS)
@@ -508,13 +506,13 @@
 }
 
 const char *
-fqdnFromAddr(struct sockaddr *addr)
+fqdnFromAddr(struct in_addr addr)
 {
     const char *n;
-    static char buf[80];
+    static char buf[32];
     if (Config.onoff.log_fqdn && (n = fqdncache_gethostbyaddr(addr, 0)))
 	return n;
-    xstrncpy(buf, sockaddr_ntoa(addr), 80);
+    xstrncpy(buf, inet_ntoa(addr), 32);
     return buf;
 }
 
Index: squid/src/ftp.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ftp.c,v
retrieving revision 1.5.2.9
retrieving revision 1.5.2.10
diff -u -r1.5.2.9 -r1.5.2.10
--- squid/src/ftp.c	1 Jul 2007 05:44:22 -0000	1.5.2.9
+++ squid/src/ftp.c	2 Jul 2007 07:36:59 -0000	1.5.2.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ftp.c,v 1.5.2.9 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: ftp.c,v 1.5.2.10 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 9     File Transfer Protocol (FTP)
  * AUTHOR: Harvest Derived
@@ -81,8 +81,6 @@
 };
 
 typedef struct _Ftpdata {
-    hash_link hash; /* dummy, must be fist */
-    int ia_cur;
     StoreEntry *entry;
     request_t *request;
     char user[MAX_URL];
@@ -1069,11 +1067,7 @@
 	strCat(ftpState->title_url, ftpState->user);
 	strCat(ftpState->title_url, "@");
     }
-    if (strchr(request->host, ':'))
-	strCat(ftpState->title_url, "[");
     strCat(ftpState->title_url, request->host);
-    if (strchr(request->host, ':'))
-	strCat(ftpState->title_url, "]");
     if (request->port != urlDefaultPort(PROTO_FTP)) {
 	strCat(ftpState->title_url, ":");
 	strCat(ftpState->title_url, xitoa(request->port));
@@ -1733,7 +1727,7 @@
 ftpSendPasv(FtpStateData * ftpState)
 {
     int fd;
-    struct sockaddr_storage addr;
+    struct sockaddr_in addr;
     socklen_t addr_len;
     if (ftpState->request->method == METHOD_HEAD && (ftpState->flags.isdir || ftpState->size != -1)) {
 	/* Terminate here for HEAD requests */
@@ -1766,14 +1760,10 @@
 	return;
     }
     /* Open data channel with the same local address as control channel */
-    if (addr.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&addr)->sin6_port = 0;
-    else
-	((struct sockaddr_in *)&addr)->sin_port = 0;
-
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	&addr,
+	addr.sin_addr,
+	0,
 	COMM_NONBLOCKING,
 	storeUrl(ftpState->entry));
     debug(9, 3) ("ftpSendPasv: Unconnected data socket created on FD %d\n", fd);
@@ -1792,10 +1782,7 @@
      * managed correctly and comm close handlers are cbdata fenced
      */
     ftpState->data.fd = fd;
-    if (addr.ss_family == AF_INET6)
-	snprintf(cbuf, 1024, "EPSV\r\n");
-    else
-	snprintf(cbuf, 1024, "PASV\r\n");
+    snprintf(cbuf, 1024, "PASV\r\n");
     ftpWriteCommand(cbuf, ftpState);
     ftpState->state = SENT_PASV;
     /*
@@ -1816,22 +1803,12 @@
     int fd = ftpState->data.fd;
     char *buf;
     LOCAL_ARRAY(char, ipaddr, 1024);
-    struct sockaddr_storage ipaddr_sock;
-    socklen_t addr_len;
     debug(9, 3) ("This is ftpReadPasv\n");
-    addr_len = sizeof(ipaddr_sock);
-    if (getsockname(ftpState->ctrl.fd, (struct sockaddr *) &ipaddr_sock, &addr_len)) {
-	debug(9, 0) ("ftpSendPasv: getsockname(%d,..): %s\n",
-	    ftpState->ctrl.fd, xstrerror());
-	ftpFail(ftpState);
-	return;
-    }
-    if (code != 227 && code != 229) {
+    if (code != 227) {
 	debug(9, 3) ("PASV not supported by remote end\n");
 	ftpSendPort(ftpState);
 	return;
     }
-    if (code == 227) {
     /*  227 Entering Passive Mode (h1,h2,h3,h4,p1,p2).  */
     /*  ANSI sez [^0-9] is undefined, it breaks on Watcom cc */
     debug(9, 5) ("scanning: %s\n", ftpState->ctrl.last_reply);
@@ -1843,24 +1820,12 @@
 	return;
     }
     snprintf(ipaddr, 1024, "%d.%d.%d.%d", h1, h2, h3, h4);
-    port = ((p1 << 8) + p2);
-    memset(&ipaddr_sock, 0, sizeof(ipaddr_sock));
-    if (!safe_inet_addr(ipaddr, &ipaddr_sock)) {
+    if (!safe_inet_addr(ipaddr, NULL)) {
 	debug(9, 1) ("Unsafe PASV reply from %s: %s\n", fd_table[ftpState->ctrl.fd].ipaddr, ftpState->ctrl.last_reply);
 	ftpSendPort(ftpState);
 	return;
     }
-    }
-    if (code == 229) {
-    debug(9, 5) ("scanning: %s\n", ftpState->ctrl.last_reply);
-    buf = ftpState->ctrl.last_reply + strcspn(ftpState->ctrl.last_reply, "(");
-    n = sscanf(buf, "(|||%d||)",&p1);
-    port = p1;
-    }
-    if (ipaddr_sock.ss_family == AF_INET)
-	((struct sockaddr_in *)&ipaddr_sock)->sin_port = htons(port);
-    if (ipaddr_sock.ss_family == AF_INET6)
-	((struct sockaddr_in6 *)&ipaddr_sock)->sin6_port = htons(port);
+    port = ((p1 << 8) + p2);
     if (0 == port) {
 	debug(9, 1) ("Unsafe PASV reply from %s: %s\n", fd_table[ftpState->ctrl.fd].ipaddr, ftpState->ctrl.last_reply);
 	ftpSendPort(ftpState);
@@ -1877,13 +1842,12 @@
     if (Config.Ftp.sanitycheck)
 	ftpState->data.host = xstrdup(fd_table[ftpState->ctrl.fd].ipaddr);
     else
-	ftpState->data.host = xstrdup(sockaddr_ntoa(&ipaddr_sock));
+	ftpState->data.host = xstrdup(ipaddr);
     safe_free(ftpState->ctrl.last_command);
     safe_free(ftpState->ctrl.last_reply);
     ftpState->ctrl.last_command = xstrdup("Connect to server data port");
-    ftpState->ia_cur = -1;
     debug(9, 5) ("ftpReadPasv: connecting to %s, port %d\n", ftpState->data.host, ftpState->data.port);
-    commConnectStart(fd, ftpState->data.host, port, ftpPasvCallback, ftpState, NULL);
+    commConnectStart(fd, ipaddr, port, ftpPasvCallback, ftpState, NULL);
 }
 
 static void
@@ -1906,7 +1870,7 @@
 ftpOpenListenSocket(FtpStateData * ftpState, int fallback)
 {
     int fd;
-    struct sockaddr_storage addr;
+    struct sockaddr_in addr;
     socklen_t addr_len;
     int on = 1;
     u_short port = 0;
@@ -1934,13 +1898,12 @@
      */
     if (fallback) {
 	setsockopt(ftpState->ctrl.fd, SOL_SOCKET, SO_REUSEADDR, (char *) &on, sizeof(on));
-	port = (addr.ss_family == AF_INET6) ?
-	ntohs(((struct sockaddr_in6 *)&addr)->sin6_port) : 
-	ntohs(((struct sockaddr_in *)&addr)->sin_port);
+	port = ntohs(addr.sin_port);
     }
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	&addr,
+	addr.sin_addr,
+	port,
 	COMM_NONBLOCKING | (fallback ? COMM_REUSEADDR : 0),
 	storeUrl(ftpState->entry));
     debug(9, 3) ("ftpOpenListenSocket: Unconnected data socket created on FD %d\n", fd);
@@ -1962,7 +1925,7 @@
 ftpSendPort(FtpStateData * ftpState)
 {
     int fd;
-    struct sockaddr_storage addr;
+    struct sockaddr_in addr;
     socklen_t addr_len;
     unsigned char *addrptr;
     unsigned char *portptr;
@@ -1976,18 +1939,11 @@
 	ftpFail(ftpState);
 	return;
     }
-    if (addr.ss_family == AF_INET) {
-    addrptr = (unsigned char *) &((struct sockaddr_in *)&addr)->sin_addr.s_addr;
-    portptr = (unsigned char *) &((struct sockaddr_in *)&addr)->sin_port;
+    addrptr = (unsigned char *) &addr.sin_addr.s_addr;
+    portptr = (unsigned char *) &addr.sin_port;
     snprintf(cbuf, 1024, "PORT %d,%d,%d,%d,%d,%d\r\n",
 	addrptr[0], addrptr[1], addrptr[2], addrptr[3],
 	portptr[0], portptr[1]);
-    }
-    if (addr.ss_family == AF_INET6) {
-    snprintf(cbuf, 1024, "EPRT |2|%s|%u|\r\n",
-	sockaddr_ntoa(&addr), 
-	ntohs(((struct sockaddr_in6 *)&addr)->sin6_port));
-    }
     ftpWriteCommand(cbuf, ftpState);
     ftpState->state = SENT_PORT;
 }
@@ -2010,7 +1966,7 @@
 ftpAcceptDataConnection(int fd, void *data)
 {
     FtpStateData *ftpState = data;
-    struct sockaddr_storage my_peer, me;
+    struct sockaddr_in my_peer, me;
     debug(9, 3) ("ftpAcceptDataConnection\n");
 
     if (EBIT_TEST(ftpState->entry->flags, ENTRY_ABORTED)) {
@@ -2019,9 +1975,9 @@
     }
     fd = comm_accept(fd, &my_peer, &me);
     if (Config.Ftp.sanitycheck) {
-	char *ipaddr = sockaddr_ntoa(&my_peer);
+	char *ipaddr = inet_ntoa(my_peer.sin_addr);
 	if (strcmp(fd_table[ftpState->ctrl.fd].ipaddr, ipaddr) != 0) {
-	    debug(9, 1) ("FTP data connection from unexpected server (%s:%d), expecting %s\n", ipaddr, (int) 0/*ntohs(my_peer.sin_port)*/, fd_table[ftpState->ctrl.fd].ipaddr);
+	    debug(9, 1) ("FTP data connection from unexpected server (%s:%d), expecting %s\n", ipaddr, (int) ntohs(my_peer.sin_port), fd_table[ftpState->ctrl.fd].ipaddr);
 	    comm_close(fd);
 	    commSetSelect(ftpState->data.fd,
 		COMM_SELECT_READ,
@@ -2041,10 +1997,8 @@
     comm_close(ftpState->data.fd);
     debug(9, 3) ("ftpAcceptDataConnection: Connected data socket on FD %d\n", fd);
     ftpState->data.fd = fd;
-    ftpState->data.port = (my_peer.ss_family == AF_INET6) ?
-	ntohs(((struct sockaddr_in6 *)&my_peer)->sin6_port) :
-	ntohs(((struct sockaddr_in *)&my_peer)->sin_port);
-    ftpState->data.host = xstrdup(sockaddr_ntoa(&my_peer));
+    ftpState->data.port = ntohs(my_peer.sin_port);
+    ftpState->data.host = xstrdup(inet_ntoa(my_peer.sin_addr));
     commSetTimeout(ftpState->ctrl.fd, -1, NULL, NULL);
     commSetTimeout(ftpState->data.fd, Config.Timeout.read, ftpTimeout,
 	ftpState);
Index: squid/src/globals.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/globals.h,v
retrieving revision 1.4.4.7
retrieving revision 1.4.4.8
diff -u -r1.4.4.7 -r1.4.4.8
--- squid/src/globals.h	1 Jul 2007 05:44:22 -0000	1.4.4.7
+++ squid/src/globals.h	2 Jul 2007 07:36:59 -0000	1.4.4.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: globals.h,v 1.4.4.7 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: globals.h,v 1.4.4.8 2007/07/02 07:36:59 amosjeffries Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -97,9 +97,6 @@
 extern int theInIcpConnection;	/* -1 */
 extern int theOutIcpConnection;	/* -1 */
 extern int DnsSocket;		/* -1 */
-extern int theInIcpConnection6;	/* -1 */
-extern int theOutIcpConnection6;	/* -1 */
-extern int DnsSocket6;		/* -1 */
 #ifdef SQUID_SNMP
 extern int theInSnmpConnection;	/* -1 */
 extern int theOutSnmpConnection;	/* -1 */
@@ -111,8 +108,7 @@
 extern struct in_addr any_addr;
 extern struct in_addr local_addr;
 extern struct in_addr no_addr;
-extern struct sockaddr_storage theOutICPAddr;
-extern struct sockaddr_storage theOutICPAddr6;
+extern struct in_addr theOutICPAddr;
 extern struct in_addr theOutSNMPAddr;
 extern struct timeval current_time;
 extern struct timeval squid_start;
Index: squid/src/http.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/http.c,v
retrieving revision 1.5.2.7
retrieving revision 1.5.2.8
diff -u -r1.5.2.7 -r1.5.2.8
--- squid/src/http.c	1 Jul 2007 05:44:22 -0000	1.5.2.7
+++ squid/src/http.c	2 Jul 2007 07:36:59 -0000	1.5.2.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: http.c,v 1.5.2.7 2007/07/01 05:44:22 amosjeffries Exp $
+ * $Id: http.c,v 1.5.2.8 2007/07/02 07:36:59 amosjeffries Exp $
  *
  * DEBUG: section 11    Hypertext Transfer Protocol (HTTP)
  * AUTHOR: Harvest Derived
@@ -804,11 +804,11 @@
 	    clientPinConnection(orig_request->pinned_connection, fd, orig_request, httpState->peer, request->flags.connection_auth);
 	} else if (httpState->peer) {
 	    if (httpState->peer->options.originserver)
-		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, httpState->orig_request->host, client_addr);
+		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, httpState->orig_request->host, client_addr, client_port);
 	    else
-		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, NULL, client_addr);
+		pconnPush(fd, httpState->peer->name, httpState->peer->http_port, NULL, client_addr, client_port);
 	} else {
-	    pconnPush(fd, request->host, request->port, NULL, client_addr);
+	    pconnPush(fd, request->host, request->port, NULL, client_addr, client_port);
 	}
 	fwdComplete(httpState->fwd);
 	httpState->fd = -1;
@@ -1211,18 +1211,10 @@
     }
     /* append X-Forwarded-For */
     if (opt_forwarded_for) {
-	char orig_forward[100] = "unknown";
-	if (opt_forwarded_for) {
-	    if ((orig_request->client_addr.ss_family == AF_INET) &&
-	    	(((struct sockaddr_in *)&orig_request->client_addr)->sin_addr.s_addr != no_addr.s_addr) )
-		strncpy(orig_forward, sockaddr_ntoa(&orig_request->client_addr), 100);
-	    if ((orig_request->client_addr.ss_family == AF_INET6) &&
-		!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&orig_request->client_addr)->sin6_addr))
-		strncpy(orig_forward, sockaddr_ntoa(&orig_request->client_addr),
-			100);
-	}
 	strFwd = httpHeaderGetList(hdr_in, HDR_X_FORWARDED_FOR);
-	strListAdd(&strFwd, orig_forward, ',');
+	strListAdd(&strFwd,
+	    (((orig_request->client_addr.s_addr != no_addr.s_addr) && opt_forwarded_for) ?
+		inet_ntoa(orig_request->client_addr) : "unknown"), ',');
 	httpHeaderPutStr(hdr_out, HDR_X_FORWARDED_FOR, strBuf(strFwd));
 	stringClean(&strFwd);
     }
@@ -1544,7 +1536,7 @@
 	if (httpState->reply_hdr_state >= 2 && !httpState->flags.abuse_detected) {
 	    httpState->flags.abuse_detected = 1;
 	    debug(11, 1) ("httpSendRequestEntryDone: Likely proxy abuse detected '%s' -> '%s'\n",
-		sockaddr_ntoa(&httpState->orig_request->client_addr),
+		inet_ntoa(httpState->orig_request->client_addr),
 		storeUrl(httpState->entry));
 	    if (httpState->entry->mem_obj->reply->sline.status == HTTP_INVALID_HEADER) {
 		memFree8K(buf);
